{% extends "ajax/game/game.html.twig" %}
{% block title %}{{'Wiedergeburt: Wahl der Partie'|trans({}, 'ghost')|raw}}{% endblock %}
{% block ajax %}
    <div class="row soul">
        <div class="cell-small header rw-18 ro-3 rw-lg-20 ro-lg-2 rw-md-24 ro-md-0 edge-top-left">
            <div class="tabs">
                <div class="tab-floater">
                    <div class="tab left inline">
                        {% include "ajax/soul/playeravatar.html.twig" with {user: app.user, small: true, fallback: false} only %}
                        <h4 class="soul-name">
                            <a class="username">{{ app.user.name }}</a>
                        </h4>
                        <div class="town-join-rp hide-sm">
                            <span class="town-join-rp-head">
                                {% trans from 'ghost' %}
                                    Ein neues Leben beginnen
                                {% endtrans %}
                            </span>
                            <div class="town-join-rp-text">
                                {% trans from 'ghost' %}
                                    ...und mit 39 Mitbürgern in der Hölle schmoren
                                {% endtrans %}
                            </div>
                        </div>
                    </div>
                    <div class="tab tab-floater">
                        {% if canCreateTown %}
                            <div class="tab">
                                <div class="tab-link" x-ajax-sticky x-ajax-href="{{ path('ghost_create_town') }}"><img src="{{ asset('build/images/item/item_chair.gif') }}" alt=""/><span class="hide-md hide-sm"> {% trans from 'ghost' %}Privatstadt gründen{% endtrans %}</span></div>
                            </div>
                            <div class="tab selected">
                                <div class="tab-link"><img src="{{ asset('build/images/icons/small_world.gif') }}" alt="" /><span class="hide-md hide-sm"> {% trans from 'ghost' %}Einer Stadt beitreten{% endtrans %}</span></div>
                            </div>

                        {% endif %}
                    </div>
                </div>
            </div>

            <div class="row">
                <div class="padded cell rw-12">
                    <div class="row">
                        <div class="cell rw-12">
                            {% if cdm_level == 2 %}

                                <div class="note note-warning">
                                    {% trans from 'ghost' %}
                                        Da du in mehreren deiner letzten Städte frühzeitig durch Verdursten gestorben bist, bist du für einige Zeit vom Spiel ausgeschlossen. Du kannst aktuell keine neue Stadt betreten.
                                    {% endtrans %}
                                </div>

                            {% else %}
                                {% if cdm_level == 1 %}
                                    <div class="note note-warning">
                                        {% trans from 'ghost' %}
                                            Du bist in mehreren deiner letzten Städte frühzeitig durch Verdursten gestorben. Sollte dies in deiner nächsten Stadt erneut geschehen, wirst du für einige Wochen vom Spiel ausgeschlossen.
                                        {% endtrans %}
                                    </div>
                                {% endif %}

                                {% set coa_link = '<a href="#" x-ajax-href="' ~ path('soul_coalitions') ~ '">' ~ ('Koalition'|trans({},'soul')) ~ '</a>' %}

                                {% if warnCoaInactive %}
                                    <div class="note note-critical">
                                        {{ 'Achtung: Du stehst deiner {coalition} NICHT ZUR VERFÜGUNG! Das bedeutet, dass du diese Partie allein spielen wirst.'|trans({ coalition: coa_link },'ghost')|raw }}
                                    </div>
                                {% elseif warnCoaEmpty %}
                                    <div class="note note-critical">
                                        {{ 'Achtung: Im Moment steht kein Mitglied deiner {coalition} zur Verfügung, um dir in eine Stadt zu folgen.'|trans({ coalition: coa_link },'ghost')|raw }}
                                    </div>
                                {% elseif warnCoaNotComplete %}
                                    <div class="note note-critical">
                                        {{ 'Achtung: Im Moment stehen nicht alle Mitglieder deiner {coalition} zur Verfügung, um dir in eine Stadt zu folgen.'|trans({ coalition: coa_link },'ghost')|raw }}
                                    </div>
                                {% endif %}

                                {% if coa is not empty %}
                                    <div class="note">
                                        {{ 'Wenn du eine Stadt betrittst, werden folgende Mitglieder deiner {coalition} dir folgen:'|trans({ coalition: coa_link },'ghost')|raw }}<br />
                                        <ul class="list no-margin">
                                        {% for member in coa %}
                                            <li><strong>{{ member.name }}</strong></li>
                                        {% endfor %}
                                        </ul>
                                    </div>
                                {% endif %}

                            {% endif %}

                            <div class="town-random hide-sm hide-md">
                                <div class="label row-flex v-center"><div class="padded cell">{{ 'Wähle dein nächstes Leben:'|trans({},'ghost') }}</div></div>
                            </div>

                            {% for townClass in townClasses %}

                                {% set joinable = userCanJoin[townClass.name] %}
                                {% set unjoinableReason = userCantJoinReason[townClass.name] %}
                                {% set found = false %}
                                {% for town in townClass.towns %}
                                    {% if town.open and town.scheduledFor < 'now'|to_date %}{% set found = true %}{% endif %}
                                {% endfor %}

                                <h5>{{ townClass.getLabel|trans({},'game') }} {% if townClass.help %}{{ help_btn( townClass.help|trans({splimit: sp_limits[townClass.name] ?? 0},'game') ) }}{% endif %}</h5>
                                {% if found %}
                                    <div class="row-table">
                                        <div class="row-flex header bottom small">
                                            <div class="padded cell rw-1">&nbsp;</div>
                                            <div class="padded cell rw-6 hide-sm">{% trans from 'ghost' %}Stadtname{% endtrans %}</div>
                                            <div class="padded cell rw-2 hide-sm">{% trans from 'game' %}Bürger{% endtrans %}</div>
                                            <div class="padded cell rw-3 hide-sm">
                                                {% trans from 'game' %}Kleine Koalitionen{% endtrans %}
                                                {{ help_btn('Gibt an, wie viele Bürger diese Stadt gemeinsam mit einer Koalition betreten haben. Es werden sowohl Spieler gezählt die automatisch mit ihrer Koalition beitreten als auch solche, die manuell anderen Spielern aus ihrer Koalition folgen.'|trans({},'game')) }}
                                            </div>
                                            {# <div class="padded cell rw-3 hide-sm right">{% trans from 'ghost' %}Aktionen{% endtrans %}</div> #}
                                        </div>
                                        {% for town in townClass.towns %}
                                            {# @var town \App\Entity\Town #}
                                            {% if town.open and town.scheduledFor < 'now'|to_date and not town.userInTown(app.user) %}
                                                {% set found = true %}
                                                <div class="row-flex wrap town-row v-center">
                                                    <div class="padded cell rw-1 rw-sm-2"><span class="language"><img src="{{ asset("build/images/lang/" ~ town.getLanguage ~ ".png") }}" alt="{{ town.getLanguage }}" /></span></div>
                                                    <div class="padded cell rw-6 rw-sm-10">
                                                        {% if not joinable and unjoinableReason is not null %}
                                                            <div class="tooltip">{{ unjoinableReason }}</div>
                                                        {% endif %}
                                                        {% if town.password is not null or town|whitelisted %}
                                                            <span>
                                                                <img src="{{ asset('build/images/item/item_lock.gif') }}" alt="Verrouillé" />
                                                                <div class="tooltip">
                                                                    <div>{% if town.password %}{{ 'Diese Stadt ist durch ein Passwort geschützt.'|trans({},'ghost') }}{% endif %}</div>
                                                                    <div>{% if town|whitelisted %}{{ 'Für diese Stadt gilt eine Platzreservierung.'|trans({},'ghost') }}{% endif %}</div>
                                                                </div>
                                                            </span>
                                                        {% endif %}
                                                            {% if cdm_level != 2 %}
                                                                <a {% if town|openFor(app.user) and (not town|whitelisted or town|whitelisted(app.user)) %}x-coa-restricted="{{ (coa is not empty and (town|whitelisted or town.password)) ? 1 : 0 }}" x-coa-discard="{{ coa|filter( member => not town|openFor(member) )|map( member => member.name )|join(';') }}" x-town-lang="{{ town.getLanguage }}" x-town-id="{{ town.id }}" x-town-name="{{ town.name }}" x-town-locked="{% if town.password is not null %}1{% else %}0{% endif %}" {% else %}disabled="disabled"{% endif %}>
                                                                    <span class="link">{{ town.name }}</span>
                                                                    {% if town.language != 'multi' and town.language != app.user.language and joinable %}
                                                                            <img alt="!" src="{{ asset('build/images/icons/warning_anim.gif') }}" />
                                                                            <div class="tooltip">
                                                                                {{ 'Die Sprache dieser Stadt stimmt nicht mit deiner Spracheinstellung überein. Wenn du dieser Stadt beitrittst, musst du im Stadtforum die Sprache der Stadt verwenden.'|trans({},'ghost') }}<br/>
                                                                                <b>{{ 'Die Verwendung einer anderen Sprache im Stadtforum kann zu Sanktionen seitens der Moderation führen!'|trans({},'ghost') }}</b>
                                                                            </div>
                                                                    {% else %}
                                                                        <img style="opacity: 0" alt="" src="{{ asset('build/images/icons/warning_anim.gif') }}" />
                                                                    {% endif %}
                                                                </a>
                                                            {% else %}
                                                                {{ town.name }}
                                                            {% endif %}

                                                        {% if town.rankingEntry.event %}
                                                            <div class="small"><i>{{ 'Event-Stadt'|trans({},'ghost') }}</i> {{ help_btn('Dies ist eine Event-Stadt, sie wird nach ihrem Ende nicht im Ranking erscheinen. Möglicherweise gelten unübliche Regeln für diese Stadt.'|trans({}, 'ghost')) }}</div>
                                                        {% endif %}
                                                    </div>
                                                    <div class="padded cell rw-2 rw-sm-5"><div class="small hide-desktop hide-lg hide-md">{% trans from 'game' %}Bürger{% endtrans %}</div>{{ town.citizens|length }}/{{ town.population }}</div>
                                                    <div class="padded cell rw-2 rw-sm-5"><div class="small hide-desktop hide-lg hide-md">{% trans from 'game' %}Kleine Koalitionen{% endtrans %}</div>{{ town.coalizedCitizenCount }}/{{ town.population }}</div>
                                                    <div class="padded cell rw-1 rw-sm-2 right">
                                                        {% if town.citizens|length > 0 %}
                                                            <img x-town-details="{{ town.id }}" x-town-toggle="{{ town.id }}" class="pointer" alt="+" src="{{ asset('build/images/icons/small_more.gif') }}" />
                                                            <div class="tooltip help">{{ 'Die Liste der eingeschriebenen Spieler ansehen.'|trans({},'game') }}</div>
                                                        {% endif %}
                                                    </div>
                                                    <div x-town-details="{{ town.id }}" class="padded cell rw-12 hidden" style="background-color: #3b3249;">
                                                        <ul class="citizen-list">
                                                            {% for denizen in town.citizens|sort((a,b) => (a.alive == b.alive) ? ((a.alive) ? a.user.name|lower <=> b.user.name|lower : b.survivedDays <=> a.survivedDays) : b.alive <=> a.alive) %}
                                                                {# @var denizen \App\Entity\Citizen #}
                                                                <li>
                                                                    {% if denizen.alive %}
                                                                        <img src="{{ asset('build/images/professions/' ~ denizen.profession.icon ~ '.gif') }}" alt="{{ denizen.profession.label|trans({},'game') }}" />
                                                                    {% else %}
                                                                        <img src="{{ asset('build/images/professions/death.gif') }}" alt="{{ denizen.profession.label|trans({},'game') }}" />
                                                                    {% endif %}

                                                                    {% include 'ajax/soul/playername.html.twig' with {user: denizen.user, tag: 'a'} only %}
                                                                </li>
                                                            {% endfor %}
                                                        </ul>
                                                        <div class="right"><span class="small pointer" x-town-toggle="{{ town.id }}">{{ 'Schließen'|trans({},'global') }}</span></div>
                                                    </div>
                                                </div>
                                            {% endif %}
                                        {% endfor %}
                                    </div>

                                {% else %}
                                    <span class="small">{% trans from 'ghost' %}Aktuell gibt es keine Stadt diesen Typs.{% endtrans %}</span>
                                {% endif %}
                            {% endfor %}
                        </div>
                    </div>
                </div>
            </div>

            <div class="row">
                <div class="cell padded rw-12">
                    <div class="small"><img alt="" src="{{ asset('build/images/icons/small_rp.gif') }}" /> {{'Beginne ein neues Leben in der Welt der Verdammten une versuche, so lang wie möglich zu überleben. Wer weiß, ws dich in dieser neuen Stadt erwarten wird?'|trans({}, 'ghost')}}</div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}
{% block js %}
    {{parent()}}
    <script>
        $.html.addEventListenerAll( '[x-town-toggle]', 'click', function(e,elem) {
            const id = elem.getAttribute('x-town-toggle');
            document.querySelectorAll('[x-town-details="' + id + '"]').forEach(function( target ) {
                if (target.classList.contains('hidden')) target.classList.remove('hidden');
                else target.classList.add('hidden');
            })
        } );

        $.html.addEventListenerAll( 'a[x-town-id][x-town-lang]', 'click', function(e,elem) {
            e.preventDefault();
            const user_lang = '{{ app.request.locale|e('js') }}';
            const town_lang = elem.getAttribute('x-town-lang');
            const town_name = elem.getAttribute('x-town-name');

            const coa_restriction = elem.getAttribute('x-coa-restricted') === '1';
            const coa_discard = elem.getAttribute('x-coa-discard') ? elem.getAttribute('x-coa-discard').split(';') : [];

            if (user_lang && town_lang && user_lang.split('_')[0] !== town_lang.split('_')[0] && town_lang !== 'multi') {
                const user_lang_rep = window.c.langs[user_lang.split('_')[0]] ? window.c.langs[user_lang.split('_')[0]] : user_lang;
                const town_lang_rep = window.c.langs[town_lang.split('_')[0]] ? window.c.langs[town_lang.split('_')[0]] : town_lang;
                let message =
                    ('{{ 'Die Sprache der gewählten Stadt ist {lang_town}. Deine aktuelle Spracheinstellung ist {lang_user}.'|trans({},'ghost')|e('js') }}' + "\n\n" +
                    '{{ 'Kommunikation ist wichtig in MyHordes. Bitte betritt keine Stadt, deren Sprache du nicht beherrscht. Möchtest du fortfahren?'|trans({},'ghost')|e('js') }}')
                    .replace(/{lang_user}/g, user_lang_rep).replace(/{lang_town}/g, town_lang_rep);

                if (!confirm(message)) return;
            } else if (!confirm('{{ 'Möchtest du die schreckliche Welt der Verdammten als Bürge der Stadt {town_name} betreten'|trans({},'ghost')|e('js') }} ?'.replace('{town_name}', town_name)))
                return;

            {% if cdm_level == 1 %}
                if (!confirm('{{ 'Du bist in mehreren deiner letzten Städte frühzeitig durch Verdursten gestorben. Sollte dies in deiner nächsten Stadt erneut geschehen, wirst du für einige Wochen vom Spiel ausgeschlossen.'|trans({},'ghost')|e('js') }}')) return;
            {% endif %}

            {% if coa is not empty %}
                if (coa_restriction && !confirm('{{ 'Diese Stadt verfügt über eine Zugangsbeschränkung. Die Mitglieder deiner Koalition können dir nicht automatisch folgen, wenn du diese Stadt betrittst. Fortfahren?'|trans({},'ghost')|e('js') }}')) return;
                if (coa_discard.length && !confirm('{{ 'Die folgenden Koalitionsmitglieder können dir nicht in die ausgewählte Stadt folgen. Fortfahren?'|trans({},'ghost')|e('js') }}' + "\n\n" + coa_discard.join("\n"))) return;
            {% endif %}

            const pass = (elem.getAttribute('x-town-locked') === '1') ? prompt('{{ 'Bitte gib das Stadtpasswort ein :'|trans({}, 'ghost') }}') : '';
            $.ajax.easySend( '{{ path('api_join') }}', {town: elem.getAttribute('x-town-id'), pass: pass},
                function () {
                    $.ajax.load(null, '{{ path('game_landing') }}', true);
                }
            );
        } );
    </script>
{% endblock %}